import { AsyncActionCreators, AnyAction } from 'typescript-fsa';
import { SagaIterator } from 'redux-saga';
export declare function bindAsyncAction<P, R>(actionCreators: AsyncActionCreators<P, R, any>): {
    (worker: (action: AnyAction) => Promise<R> | SagaIterator): (action: AnyAction) => SagaIterator;
    <A1>(worker: (action: AnyAction, arg1: A1) => Promise<R> | SagaIterator): (action: AnyAction, arg1: A1) => SagaIterator;
    <A1, A2>(worker: (action: AnyAction, arg1: A1, arg2: A2) => Promise<R> | SagaIterator): (action: AnyAction, arg1: A1, arg2: A2) => SagaIterator;
    <A1, A2, A3>(worker: (action: AnyAction, arg1: A1, arg2: A2, arg3: A3, ...rest: any[]) => Promise<R> | SagaIterator): (action: AnyAction, arg1: A1, arg2: A2, arg3: A3, ...rest: any[]) => SagaIterator;
};
