"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var typescript_fsa_1 = require("typescript-fsa");
var effects_1 = require("redux-saga/effects");
function bindAsyncAction(actionCreator) {
    return function (worker) {
        return function (action) {
            var args = [];
            for (_i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var _i, result, error_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!typescript_fsa_1.isType(action, actionCreator.started)) return [3 /*break*/, 10];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, 6, 10]);
                        return [4 /*yield*/, effects_1.call.apply(void 0, [worker, action].concat(args))];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, effects_1.put(actionCreator.done({
                                params: action.payload,
                                result: result
                            }))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, result];
                    case 4:
                        error_1 = _a.sent();
                        return [4 /*yield*/, effects_1.put(actionCreator.failed({ params: action.payload, error: error_1 }))];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 6: return [4 /*yield*/, effects_1.cancelled()];
                    case 7:
                        if (!_a.sent()) return [3 /*break*/, 9];
                        return [4 /*yield*/, effects_1.put(actionCreator.failed({
                                params: action.payload,
                                error: 'cancelled'
                            }))];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9: return [7 /*endfinally*/];
                    case 10: return [2 /*return*/];
                }
            });
        };
    };
}
exports.bindAsyncAction = bindAsyncAction;
//# sourceMappingURL=index.js.map